//  Created by Robin Speijer on 25-06-18.
//  Copyright © 2018 Bohemian Coding. All rights reserved.

@class SCKAPIEnvironment;
@class SCKAPIAuthentication;

NS_ASSUME_NONNULL_BEGIN

NS_SWIFT_NAME(APIRequest)
@protocol SCKAPIRequest <NSObject>

/// The environment to perform this API request against.
@property (nonatomic, copy) SCKAPIEnvironment *environment;

/// The authentication session that this request should be part of. Usually an instance of an authenticated user.
@property (nonatomic, nullable, strong) SCKAPIAuthentication *authentication;

/// The autogenerated URLRequest instance to perform.
@property (nonatomic, readonly) NSURLRequest *urlRequest;

@end

NS_ASSUME_NONNULL_END
